/// <reference types="node" />
/// <reference types="node" />
import type { ImplementationDetails } from '@clickhouse/client-common';
import { type BaseClickHouseClientConfigOptions } from '@clickhouse/client-common';
import type Stream from 'stream';
export type NodeClickHouseClientConfigOptions = BaseClickHouseClientConfigOptions & {
    tls?: BasicTLSOptions | MutualTLSOptions;
    /** HTTP Keep-Alive related settings */
    keep_alive?: {
        /** Enable or disable HTTP Keep-Alive mechanism.
         *  @default true */
        enabled?: boolean;
        /** For how long keep a particular idle socket alive on the client side (in milliseconds).
         *  It is supposed to be a fair bit less that the ClickHouse server KeepAlive timeout,
         *  which is by default 3000 ms for pre-23.11 versions.
         *  @default 2500 */
        idle_socket_ttl?: number;
    };
};
interface BasicTLSOptions {
    ca_cert: Buffer;
}
interface MutualTLSOptions {
    ca_cert: Buffer;
    cert: Buffer;
    key: Buffer;
}
export declare const NodeConfigImpl: Required<ImplementationDetails<Stream.Readable>['impl']>;
export {};
