"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createConnection = void 0;
const node_http_connection_1 = require("./node_http_connection");
const node_https_connection_1 = require("./node_https_connection");
function createConnection(params, tls, keep_alive) {
    switch (params.url.protocol) {
        case 'http:':
            return new node_http_connection_1.NodeHttpConnection({ ...params, keep_alive });
        case 'https:':
            return new node_https_connection_1.NodeHttpsConnection({ ...params, tls, keep_alive });
        default:
            throw new Error('Only HTTP and HTTPS protocols are supported');
    }
}
exports.createConnection = createConnection;
//# sourceMappingURL=create_connection.js.map