"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _notificationCatcherProvider = _interopRequireDefault(require("../notificationCatcherProvider"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
class EmailNotificationCatcherProvider extends _notificationCatcherProvider.default {
  async send(request) {
    const {
      to,
      from,
      html,
      text,
      subject,
      replyTo,
      attachments
    } = request.customize ? await request.customize(this.id, request) : request;
    return this.sendToCatcher({
      to,
      from,
      html,
      text,
      subject,
      replyTo,
      attachments,
      headers: {
        'X-to': `[email] ${to}`
      }
    });
  }
}
exports.default = EmailNotificationCatcherProvider;