"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _nodemailer = _interopRequireDefault(require("nodemailer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
class EmailSendmailProvider {
  id = 'email-sendmail-provider';
  constructor(config) {
    this.transporter = _nodemailer.default.createTransport(config);
  }
  async send(request) {
    const {
      customize,
      ...rest
    } = request.customize ? await request.customize(this.id, request) : request;
    const result = await this.transporter.sendMail(rest);
    return result.messageId;
  }
}
exports.default = EmailSendmailProvider;