"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = factory;
var _email = _interopRequireDefault(require("./email"));
var _sms = _interopRequireDefault(require("./sms"));
var _voice = _interopRequireDefault(require("./voice"));
var _webpush = _interopRequireDefault(require("./webpush"));
var _slack = _interopRequireDefault(require("./slack"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
function factory(channels) {
  return Object.keys(channels).reduce((acc, key) => {
    acc[key] = channels[key].providers.map(config => {
      switch (key) {
        case 'email':
          return (0, _email.default)(config);
        case 'sms':
          return (0, _sms.default)(config);
        case 'voice':
          return (0, _voice.default)(config);
        case 'webpush':
          return (0, _webpush.default)(config);
        case 'slack':
          return (0, _slack.default)(config);
        default:
          return config;
      }
    });
    return acc;
  }, {});
}