"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _smtp = _interopRequireDefault(require("./email/smtp"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
class NotificationCatcherProvider {
  static getConfig(channels) {
    return channels.reduce((config, channel) => ({
      ...config,
      [channel]: {
        providers: [{
          type: 'notificationcatcher'
        }],
        multiProviderStrategy: 'no-fallback'
      }
    }), {});
  }
  constructor(channel) {
    this.id = `${channel}-notificationcatcher-provider`;
    const options = process.env.NOTIFME_CATCHER_OPTIONS || {
      port: 1025,
      ignoreTLS: true
    };
    this.provider = new _smtp.default(options);
  }
  async sendToCatcher(request) {
    return this.provider.send(request);
  }
}
exports.default = NotificationCatcherProvider;