"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _notificationCatcherProvider = _interopRequireDefault(require("../notificationCatcherProvider"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
class SlackCatcherProvider extends _notificationCatcherProvider.default {
  async send(request) {
    const {
      text
    } = request.customize ? await request.customize(this.id, request) : request;
    this.sendToCatcher({
      to: 'public.channel@slack',
      from: '-',
      subject: `${text.substring(0, 20)}${text.length > 20 ? '...' : ''}`,
      text,
      headers: {
        'X-type': 'slack',
        'X-to': '[slack public channel]'
      }
    });
    return '';
  }
}
exports.default = SlackCatcherProvider;