"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _request = _interopRequireDefault(require("../../util/request"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
class SlackProvider {
  id = 'slack-provider';
  constructor(config) {
    this.webhookUrl = config.webhookUrl;
  }
  async send(request) {
    const {
      webhookUrl,
      ...rest
    } = request.customize ? await request.customize(this.id, request) : request;
    const apiRequest = {
      method: 'POST',
      body: JSON.stringify(rest)
    };
    const response = await (0, _request.default)(webhookUrl || this.webhookUrl, apiRequest);
    if (response.ok) {
      return ''; // Slack API only returns 'ok'
    } else {
      const responseText = await response.text();
      throw new Error(`${response.status} - ${responseText}`);
    }
  }
}
exports.default = SlackProvider;