"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _request = _interopRequireDefault(require("../../util/request"));
var _querystring = _interopRequireDefault(require("querystring"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
class Sms46elksProvider {
  id = 'sms-46elks-provider';
  constructor({
    apiUsername,
    apiPassword
  }) {
    this.apiKey = Buffer.from(`${apiUsername}:${apiPassword}`).toString('base64');
  }

  /*
   * Note: 'type', 'nature', 'ttl', 'messageClass' are not supported.
   */
  async send(request) {
    const {
      from,
      to,
      text
    } = request.customize ? await request.customize(this.id, request) : request;
    const response = await (0, _request.default)('https://api.46elks.com/a1/sms', {
      method: 'POST',
      headers: {
        Authorization: `Basic ${this.apiKey}`,
        'User-Agent': 'notifme-sdk/v1 (+https://github.com/notifme/notifme-sdk)'
      },
      body: _querystring.default.stringify({
        from,
        to,
        message: text
      })
    });
    if (response.ok) {
      const responseBody = await response.json();
      return responseBody.id;
    } else {
      throw new Error(await response.text());
    }
  }
}
exports.default = Sms46elksProvider;