"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _notificationCatcherProvider = _interopRequireDefault(require("../notificationCatcherProvider"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
class SmsNotificationCatcherProvider extends _notificationCatcherProvider.default {
  async send(request) {
    const {
      to,
      from,
      text
    } = request.customize ? await request.customize(this.id, request) : request;
    return this.sendToCatcher({
      to: `${to}@sms`,
      from,
      subject: `${text.substring(0, 20)}${text.length > 20 ? '...' : ''}`,
      text,
      headers: {
        'X-type': 'sms',
        'X-to': `[sms] ${to}`
      }
    });
  }
}
exports.default = SmsNotificationCatcherProvider;