"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = factory;
var _logger = _interopRequireDefault(require("../logger"));
var _notificationCatcher = _interopRequireDefault(require("./notificationCatcher"));
var _twilio = _interopRequireDefault(require("./twilio"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
function factory({
  type,
  ...config
}) {
  switch (type) {
    // Development
    case 'logger':
      return new _logger.default(config, 'voice');
    case 'notificationcatcher':
      return new _notificationCatcher.default('voice');

    // Custom
    case 'custom':
      return config;

    // Providers
    case 'twilio':
      return new _twilio.default(config);
    default:
      throw new Error(`Unknown voice provider "${type}".`);
  }
}