"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _notificationCatcherProvider = _interopRequireDefault(require("../notificationCatcherProvider"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
class VoiceNotificationCatcherProvider extends _notificationCatcherProvider.default {
  async send(request) {
    const {
      to,
      from,
      url
    } = request.customize ? await request.customize(this.id, request) : request;
    return this.sendToCatcher({
      to: `${to}@voice`,
      from,
      subject: `${to}@voice`,
      text: url,
      headers: {
        'X-type': 'voice',
        'X-to': `[voice] ${to}`
      }
    });
  }
}
exports.default = VoiceNotificationCatcherProvider;