"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _webPush = _interopRequireDefault(require("web-push"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
class WebpushGcmProvider {
  id = 'webpush-gcm-provider';
  constructor({
    gcmAPIKey,
    vapidDetails,
    ttl,
    headers
  }) {
    this.options = {
      TTL: ttl,
      headers
    };
    if (gcmAPIKey) {
      _webPush.default.setGCMAPIKey(gcmAPIKey);
    }
    if (vapidDetails) {
      const {
        subject,
        publicKey,
        privateKey
      } = vapidDetails;
      _webPush.default.setVapidDetails(subject, publicKey, privateKey);
    }
  }
  async send(request) {
    const {
      subscription,
      ...rest
    } = request.customize ? await request.customize(this.id, request) : request;
    const result = await _webPush.default.sendNotification(subscription, JSON.stringify(rest), this.options);
    return result.headers.location;
  }
}
exports.default = WebpushGcmProvider;