"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = factory;
var _gcm = _interopRequireDefault(require("./gcm"));
var _logger = _interopRequireDefault(require("../logger"));
var _notificationCatcher = _interopRequireDefault(require("./notificationCatcher"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
function factory({
  type,
  ...config
}) {
  switch (type) {
    // Development
    case 'logger':
      return new _logger.default(config, 'webpush');
    case 'notificationcatcher':
      return new _notificationCatcher.default('webpush');

    // Custom
    case 'custom':
      return config;

    // Providers
    case 'gcm':
      return new _gcm.default(config);
    default:
      throw new Error(`Unknown webpush provider "${type}".`);
  }
}