"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _notificationCatcherProvider = _interopRequireDefault(require("../notificationCatcherProvider"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
class WebpushNotificationCatcherProvider extends _notificationCatcherProvider.default {
  async send(request) {
    const {
      subscription,
      title,
      ...rest
    } = request.customize ? await request.customize(this.id, request) : request;
    return this.sendToCatcher({
      to: `${rest.userId ? rest.userId : 'user'}@webpush`,
      from: '-',
      subject: title,
      headers: {
        'X-type': 'webpush',
        'X-to': `[webpush] ${rest.userId ? rest.userId : ''}`,
        'X-payload': JSON.stringify({
          title,
          ...rest
        })
      }
    });
  }
}
exports.default = WebpushNotificationCatcherProvider;