"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _logger = _interopRequireDefault(require("../../util/logger"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
async function recursiveTry(providers, request) {
  const [current, ...others] = providers;
  try {
    const id = await current.send(request);
    return {
      providerId: current.id,
      id
    };
  } catch (error) {
    _logger.default.warn(current.id, error);
    if (others.length === 0) {
      // no more provider to try
      error.providerId = current.id;
      throw error;
    }
    return recursiveTry(others, request);
  }
}
const strategyProvidersFallback = providers => request => recursiveTry(providers, request);
var _default = exports.default = strategyProvidersFallback;