"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _logger = _interopRequireDefault(require("../../util/logger"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Types
const strategyProvidersNoFallback = ([provider]) => async request => {
  try {
    const id = await provider.send(request);
    return {
      providerId: provider.id,
      id
    };
  } catch (error) {
    _logger.default.warn(provider.id, error);
    error.providerId = provider.id;
    throw error;
  }
};
var _default = exports.default = strategyProvidersNoFallback;