"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _fallback = _interopRequireDefault(require("./fallback"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// "statefull" strategy
// Types
function rotate(arr, forward) {
  // /!\ mute array, the mutation is "the state"
  if (forward) {
    arr.push(arr.shift());
  } else {
    arr.unshift(arr.pop());
  }
  return arr;
}
const strategyProvidersFallback = providers => {
  const rotatedProviders = rotate(providers, false);
  return request => (0, _fallback.default)(rotate(rotatedProviders, true))(request);
};

// /!\ not equivalent to (providers) => strategyFallback(rotate(providers)) because of memoization
var _default = exports.default = strategyProvidersFallback;