"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _winston = _interopRequireDefault(require("winston"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
class Logger {
  constructor() {
    this.innerLogger = _winston.default.createLogger();
    this.configure({
      transports: [new _winston.default.transports.Console({
        colorize: true
      })]
    });
  }
  configure(options) {
    this.innerLogger.configure(options);
  }
  mute() {
    this.configure({
      transports: []
    });
  }
  log(level, info, extra) {
    this.innerLogger.log(level, info, extra);
  }
  error(info, extra) {
    this.log('error', info, extra);
  }
  warn(info, extra) {
    this.log('warn', info, extra);
  }
  info(info, extra) {
    this.log('info', info, extra);
  }
}
var _default = exports.default = new Logger();