System.register("errors/parsing-error", [], function (exports_1, context_1) {
    "use strict";
    var ParsingError;
    var __moduleName = context_1 && context_1.id;
    return {
        setters: [],
        execute: function () {
            ParsingError = class ParsingError extends Error {
                constructor(line, lineNumber) {
                    super(`Unsupported type of line: [${lineNumber}] "${line}"`);
                    this.line = line;
                    this.lineNumber = lineNumber;
                }
            };
            exports_1("ParsingError", ParsingError);
        }
    };
});
System.register("errors/proto-error", [], function (exports_2, context_2) {
    "use strict";
    var ProtoError;
    var __moduleName = context_2 && context_2.id;
    return {
        setters: [],
        execute: function () {
            ProtoError = class ProtoError extends Error {
                constructor(lineNumber) {
                    super(`Unsupported section name "__proto__": [${lineNumber}]"`);
                    this.lineNumber = lineNumber;
                }
            };
            exports_2("ProtoError", ProtoError);
        }
    };
});
System.register("errors/errors-symbol", [], function (exports_3, context_3) {
    "use strict";
    var $Errors;
    var __moduleName = context_3 && context_3.id;
    return {
        setters: [],
        execute: function () {
            exports_3("$Errors", $Errors = Symbol('Errors of parsing'));
        }
    };
});
System.register("errors/index", ["errors/parsing-error", "errors/proto-error", "errors/errors-symbol"], function (exports_4, context_4) {
    "use strict";
    var __moduleName = context_4 && context_4.id;
    function exportStar_1(m) {
        var exports = {};
        for (var n in m) {
            if (n !== "default") exports[n] = m[n];
        }
        exports_4(exports);
    }
    return {
        setters: [
            function (parsing_error_1_1) {
                exportStar_1(parsing_error_1_1);
            },
            function (proto_error_1_1) {
                exportStar_1(proto_error_1_1);
            },
            function (errors_symbol_1_1) {
                exportStar_1(errors_symbol_1_1);
            }
        ],
        execute: function () {
        }
    };
});
System.register("types/ini-object-data-section", [], function (exports_5, context_5) {
    "use strict";
    var __moduleName = context_5 && context_5.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("types/ini-value", [], function (exports_6, context_6) {
    "use strict";
    var __moduleName = context_6 && context_6.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("interfaces/ini-object-section", [], function (exports_7, context_7) {
    "use strict";
    var __moduleName = context_7 && context_7.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("proto", [], function (exports_8, context_8) {
    "use strict";
    var $Proto;
    var __moduleName = context_8 && context_8.id;
    return {
        setters: [],
        execute: function () {
            exports_8("$Proto", $Proto = Symbol('__proto__'));
        }
    };
});
System.register("interfaces/ini-object", ["errors/index", "proto"], function (exports_9, context_9) {
    "use strict";
    var errors_1, proto_1;
    var __moduleName = context_9 && context_9.id;
    return {
        setters: [
            function (errors_1_1) {
                errors_1 = errors_1_1;
            },
            function (proto_1_1) {
                proto_1 = proto_1_1;
            }
        ],
        execute: function () {
        }
    };
});
System.register("helpers/auto-type", [], function (exports_10, context_10) {
    "use strict";
    var __moduleName = context_10 && context_10.id;
    function autoType(val) {
        if (val === '') {
            return undefined;
        }
        const valLower = val.toLowerCase();
        const isTrue = valLower === 'true';
        if (isTrue || (valLower === 'false')) {
            return valLower === 'true';
        }
        if (!Number.isNaN(Number(val)) || (valLower === 'nan')) {
            return Number(val);
        }
        if (valLower === 'null') {
            return null;
        }
        return val;
    }
    exports_10("autoType", autoType);
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("interfaces/custom-typing", [], function (exports_11, context_11) {
    "use strict";
    var __moduleName = context_11 && context_11.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("parse", ["errors/index", "helpers/auto-type", "proto"], function (exports_12, context_12) {
    "use strict";
    var errors_2, auto_type_1, proto_2, KeyMergeStrategies, sectionNameRegex, decode;
    var __moduleName = context_12 && context_12.id;
    function parse(data, params) {
        const { delimiter = '=', comment = ';', nothrow = false, autoTyping = true, dataSections = [], protoSymbol = false, keyMergeStrategy = KeyMergeStrategies.OVERRIDE, } = Object.assign({}, params);
        let typeParser;
        if (typeof autoTyping === 'function') {
            typeParser = autoTyping;
        }
        else {
            typeParser = autoTyping ? auto_type_1.autoType : (val) => val;
        }
        const isOverrideStrategy = keyMergeStrategy === KeyMergeStrategies.OVERRIDE;
        const isJoinStrategy = !isOverrideStrategy
            && (keyMergeStrategy === KeyMergeStrategies.JOIN_TO_ARRAY);
        const isCustomStrategy = !isOverrideStrategy
            && !isJoinStrategy
            && typeof keyMergeStrategy === 'function';
        const lines = data.split(/\r?\n/g);
        let lineNumber = 0;
        let currentSection = '';
        let isDataSection = false;
        const result = {};
        const commentChars = Array.isArray(comment) ? comment : [comment];
        for (const rawLine of lines) {
            lineNumber += 1;
            const line = rawLine.trim();
            if ((line.length === 0) || commentChars.some((char) => line.startsWith(char))) {
                continue;
            }
            else if (line[0] === '[') {
                const match = line.match(sectionNameRegex);
                if (match) {
                    currentSection = match[1].trim();
                    if (currentSection === '__proto__') {
                        if (protoSymbol) {
                            currentSection = proto_2.$Proto;
                        }
                        else {
                            throw new errors_2.ProtoError(lineNumber);
                        }
                    }
                    isDataSection = dataSections.includes(currentSection);
                    if (!(currentSection in result)) {
                        result[currentSection] = (isDataSection) ? [] : Object.create(null);
                    }
                    continue;
                }
            }
            else if (isDataSection) {
                result[currentSection].push(rawLine);
                continue;
            }
            else if (line.includes(delimiter)) {
                const posOfDelimiter = line.indexOf(delimiter);
                const name = line.slice(0, posOfDelimiter).trim();
                const rawVal = line.slice(posOfDelimiter + 1).trim();
                const val = typeParser(rawVal, currentSection, name);
                const section = (currentSection !== '') ? result[currentSection] : result;
                if (isOverrideStrategy) {
                    section[name] = val;
                }
                else if (isJoinStrategy) {
                    if (name in section) {
                        const oldVal = section[name];
                        if (Array.isArray(oldVal)) {
                            oldVal.push(val);
                        }
                        else {
                            section[name] = [oldVal, val];
                        }
                    }
                    else {
                        section[name] = val;
                    }
                }
                else if (isCustomStrategy) {
                    keyMergeStrategy(section, name, val);
                }
                continue;
            }
            const error = new errors_2.ParsingError(line, lineNumber);
            if (!nothrow) {
                throw error;
            }
            else if (errors_2.$Errors in result) {
                result[errors_2.$Errors].push(error);
            }
            else {
                result[errors_2.$Errors] = [error];
            }
        }
        return result;
    }
    exports_12("parse", parse);
    return {
        setters: [
            function (errors_2_1) {
                errors_2 = errors_2_1;
            },
            function (auto_type_1_1) {
                auto_type_1 = auto_type_1_1;
            },
            function (proto_2_1) {
                proto_2 = proto_2_1;
            }
        ],
        execute: function () {
            exports_12("KeyMergeStrategies", KeyMergeStrategies = {
                OVERRIDE: 'override',
                JOIN_TO_ARRAY: 'join-to-array',
            });
            sectionNameRegex = /\[(.*)]$/;
            exports_12("decode", decode = parse);
        }
    };
});
System.register("stringify", [], function (exports_13, context_13) {
    "use strict";
    var encode;
    var __moduleName = context_13 && context_13.id;
    function stringify(data, params) {
        const { delimiter = '=', blankLine = true, spaceBefore = false, spaceAfter = false, skipUndefined = false, } = Object.assign({}, params);
        const chunks = [];
        const formatPare = (key, val) => {
            let result = key;
            if (spaceBefore) {
                result += ' ';
            }
            result += delimiter;
            if (spaceAfter) {
                result += ' ';
            }
            result += val;
            return result;
        };
        let sectionKeys = null;
        let curKeyId = 0;
        for (const key of Object.keys(data)) {
            while (!sectionKeys || (sectionKeys.length !== curKeyId)) {
                let curKey;
                if (sectionKeys) {
                    curKey = sectionKeys[curKeyId];
                    curKeyId += 1;
                }
                else {
                    curKey = key;
                }
                const val = (sectionKeys) ? data[key][curKey] : data[curKey];
                const valType = typeof val;
                if (['boolean', 'string', 'number'].includes(valType)) {
                    chunks.push(formatPare(curKey, val.toString()));
                    if (!sectionKeys) {
                        break;
                    }
                }
                else if (typeof val === 'object') {
                    if (sectionKeys) {
                        throw new Error('too much nesting');
                    }
                    if (blankLine) {
                        chunks.push('');
                    }
                    chunks.push(`[${key}]`);
                    if (Array.isArray(val)) {
                        // is datasection
                        chunks.push(...val);
                        break;
                    }
                    else {
                        sectionKeys = Object.keys(val);
                    }
                }
                else if (typeof val === 'undefined' && !skipUndefined) {
                    chunks.push(formatPare(curKey, ''));
                }
            }
            sectionKeys = null;
            curKeyId = 0;
        }
        return chunks.join('\n');
    }
    exports_13("stringify", stringify);
    return {
        setters: [],
        execute: function () {
            exports_13("encode", encode = stringify);
        }
    };
});
System.register("index", ["errors/index", "parse", "stringify", "proto", "types/ini-value", "types/ini-object-data-section", "interfaces/custom-typing", "interfaces/ini-object", "interfaces/ini-object-section"], function (exports_14, context_14) {
    "use strict";
    var __moduleName = context_14 && context_14.id;
    function exportStar_2(m) {
        var exports = {};
        for (var n in m) {
            if (n !== "default") exports[n] = m[n];
        }
        exports_14(exports);
    }
    return {
        setters: [
            function (errors_3_1) {
                exportStar_2(errors_3_1);
            },
            function (parse_1_1) {
                exportStar_2(parse_1_1);
            },
            function (stringify_1_1) {
                exportStar_2(stringify_1_1);
            },
            function (proto_3_1) {
                exportStar_2(proto_3_1);
            },
            function (ini_value_1_1) {
                exportStar_2(ini_value_1_1);
            },
            function (ini_object_data_section_1_1) {
                exportStar_2(ini_object_data_section_1_1);
            },
            function (custom_typing_1_1) {
                exportStar_2(custom_typing_1_1);
            },
            function (ini_object_1_1) {
                exportStar_2(ini_object_1_1);
            },
            function (ini_object_section_1_1) {
                exportStar_2(ini_object_section_1_1);
            }
        ],
        execute: function () {
        }
    };
});
