import { IIniObject } from './interfaces/ini-object';
import { IIniObjectSection } from './interfaces/ini-object-section';
import { ICustomTyping } from './interfaces/custom-typing';
export declare const KeyMergeStrategies: {
    readonly OVERRIDE: "override";
    readonly JOIN_TO_ARRAY: "join-to-array";
};
export type KeyMergeStrategyName = typeof KeyMergeStrategies[keyof typeof KeyMergeStrategies];
export type KeyMergeStrategyFunction = (section: IIniObjectSection, name: string, value: any) => void;
export interface IParseConfig {
    comment?: string | string[];
    delimiter?: string;
    nothrow?: boolean;
    autoTyping?: boolean | ICustomTyping;
    keyMergeStrategy?: KeyMergeStrategyName | KeyMergeStrategyFunction;
    dataSections?: string[];
    protoSymbol?: boolean;
}
export declare function parse(data: string, params?: IParseConfig): IIniObject;
export declare const decode: typeof parse;
